//+------------------------------------------------------------------+
//|           
//|   ,       H_Candle*  
//|     ,      
//|  ,  
//|       
//|    -  
//|    -    
//|      
//|
//|     -
//|      
//|Cnt_Bars = 1000; -      
//|Mult = 1;           1000 ; 
//| Mult = 0,    
//|Set_Lot = 0.01; - 
//|Set_Level = 7; -      
//|Set_SL = 10;   - 
//|Set_TP = 10;   - 
//|CUR_PRICE = false; -     
//|MARTIN = true; -  
//|SET_OUTLOSS = true; -   
//|Level_OutLoss = 0;  -      
//+------------------------------------------------------------------+
#property copyright "Copyright  Sergey Gulyaev. Maykop."
string Name_Expert = "ex_Two_Orders",
       Ver = "GS_2010_02_17",
       Autor = "valenok2003@mail.ru";
//+------------------------------------------------------------------+
string Name_Sound_Open  = "expert.wav";
string Name_Sound_Close = "ok.wav";
string Name_Sound_Modify = "tick.wav";
string Name_Sound_Profit = "payment.wav";
string Name_Sound_Loss = "ERROR.WAV";
//+------------------------------------------------------------------+
//+    
//+------------------------------------------------------------------+
//----------------
//----------------
//+------------------------------------------------------------------+
//+     
//+------------------------------------------------------------------+
extern int     Cnt_Bars = 1000; //     
extern double  Mult = 1;  //          1000 
extern double  Set_Lot = 0.01;
extern double  Set_Level = 7;
extern double  Set_SL = 10;
extern double  Set_TP = 10;
extern int     Tral = 0;
extern int     Hold_Before_Tral = 0; //   Hold_Before_Tral 
extern int     Magic  = 10000;
extern bool    MARTIN = true;
extern bool    HIGH_LOW = true;
extern bool    OPEN_CLOSE = false;
extern bool    CUR_PRICE = false;
extern bool    SET_OUTLOSS = true;
extern double  Level_OutLoss = 0;
extern bool Alert_ON = false;
extern bool Sound_ON = true;

int Slip;
int ERROR = 0;
//----------------
//----------------
double   H_Candle, Lot, Price, TP, SL;

string   Symbol_Name;

int   Ticket_H = 0, Ticket_L = 0, Ticket_Open = 0,
      Std_Min_Dist,
      Cnt = 0,
      Cnt_Tick = 0,
      Timer_Tral;
      
bool  TRADE_ON = true,
      OUTLOSS,
      TRADE_IS_READY = false,
      SET_TIMER_TRAL = false;

//----------------
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
//----
   OUTLOSS = SET_OUTLOSS;
   TRADE_IS_READY = false;
   Cnt_Tick = 0;
   Symbol_Name = Symbol();
   if(Digits == 5)
   {
      Set_SL = Set_SL*10;
      Set_TP = Set_TP*10;
   }
//+------------------------------------------------------------------+
//|                                     |
//+------------------------------------------------------------------+
   Set_Lot = Check_Set_Lot(Symbol_Name, Set_Lot);
//--------------------------------------------------------------------
   Lot = Set_Lot;
//--------------------------------------------------------------------
   Std_Min_Dist = MarketInfo(Symbol_Name,MODE_STOPLEVEL);
//--------------------------------------------------------------------
//----    -------------------------------------------
   if(Mult != 0)
   {  double Tmp_H = 0;
      for(int i = 0; i < Cnt_Bars; i++) Tmp_H += High[i]-Low[i];
      H_Candle = Mult*(Tmp_H/Cnt_Bars);
   }
//----
   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
//----
   Comment("");
   ObjectDelete("Advert");
//----
   return(0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
//----
   Comment("    "+ DoubleToStr(MathRound(H_Candle/Point),0) + " .\n   " + DoubleToStr(MathRound((High[1]-Low[1])/Point),0) + " .");
   //  
   Set_SL = Check_Min_Dist(Symbol_Name, Set_SL);
   Set_TP = Check_Min_Dist(Symbol_Name, Set_TP);
   Slip=MathRound((MarketInfo(OrderSymbol(),MODE_ASK)-MarketInfo(OrderSymbol(),MODE_BID))/Point);
   //-----------------------------------
   if((HIGH_LOW == true && OPEN_CLOSE == true)
   || (HIGH_LOW == true && CUR_PRICE == true)
   || (OPEN_CLOSE == true && CUR_PRICE == true))
   {  Alert("     HIGH_LOW,OPEN_CLOSE  CUR_PRICE.");
      return(0);
   }
   double Level_H;
   double Level_L;
   if(OPEN_CLOSE)
   {
      if(iHigh(Symbol_Name,0,1)-iOpen(Symbol_Name,0,1) <= iHigh(Symbol_Name,0,1)-iClose (Symbol_Name,0,1))
      {
         Level_H = iOpen(Symbol_Name,0,1);
         Level_L = iClose (Symbol_Name,0,1);
      }
      if(iHigh(Symbol_Name,0,1)-iOpen(Symbol_Name,0,1) > iHigh(Symbol_Name,0,1)-iClose (Symbol_Name,0,1))
      {
         Level_H = iClose (Symbol_Name,0,1);
         Level_L = iOpen(Symbol_Name,0,1);
      }
   }
   if(HIGH_LOW)
   {
      Level_H = iHigh(Symbol_Name,0,1);
      Level_L = iLow (Symbol_Name,0,1);
   }
   if(CUR_PRICE)
   {
      Level_H = NormalizeDouble(Bid,Digits);
      Level_L = NormalizeDouble(Bid,Digits);
   }
   //-----------------------------------
   if(TimeCurrent()- Time[0]<=1 && TRADE_IS_READY)
   {  TRADE_ON = true;
      TRADE_IS_READY = false;
   }
   //1.1.    
   if(TRADE_ON && StringSubstr(Autor,7,2) == "k2")
   {  if(Mult != 0 && H_Candle > High[1]-Low[1]) return(0);          //    
      //1.1.1.    
      if(Std_Min_Dist == MarketInfo(Symbol_Name,MODE_STOPLEVEL))
      {
         Cnt = 0;
         while(TRADE_ON == true && Cnt < 10)
         {
            Cnt++;
            //1.1.1.1.     
            if(Ticket_H <= 0)
            {
               //1.1.1.1.1.  BUY  High  
               Price = NormalizeDouble(Level_H + Set_Level*Point, Digits);
               //1.1.1.1.1.     High, 
               if(Price - Ask < Std_Min_Dist*Point)
                  //   ,    +   
                  Price = NormalizeDouble(Ask + 1.5*Std_Min_Dist*Point, Digits);
               SL = NormalizeDouble(Price - Set_SL*Point, Digits);
               TP = NormalizeDouble(Price + Set_TP*Point, Digits);
               Ticket_H = OrderSend(Symbol_Name,OP_BUYSTOP,Lot,Price,Slip,SL,TP,"Order",Magic,0,CLR_NONE);
               ERROR = GetLastError();
               if(ERROR == 0 && Sound_ON) PlaySound(Name_Sound_Open);
               Error(Name_Expert, "Order OP_BUYSTOP Set Order - ", ERROR);
            }
     
            //1.1.1.2.     
            if(Ticket_L <= 0)
            {
               //1.1.1.2.1.  SELL  Low  
               Price = NormalizeDouble(Level_L - Set_Level*Point, Digits);
                  //1.1.1.2.1.1.     Low, 
                  if(Bid - Price < Std_Min_Dist*Point)
                     //   ,    -   
                     Price = NormalizeDouble(Bid - 1.5*Std_Min_Dist*Point, Digits);
               SL = NormalizeDouble(Price + Set_SL*Point, Digits);
               TP = NormalizeDouble(Price - Set_TP*Point, Digits);
               Ticket_L = OrderSend(Symbol_Name,OP_SELLSTOP,Lot,Price,Slip,SL,TP,"BootOrder",Magic,0,CLR_NONE);
               ERROR = GetLastError();
               if(ERROR == 0 && Sound_ON) PlaySound(Name_Sound_Open);
               Error(Name_Expert, "BootOrder OP_SELLSTOP Set Order - ", ERROR);
            }
               
            //1.1.1.3.    
            if(Ticket_H > 0 && Ticket_L > 0)
               //1.1.3.1    (TRADE_ON = false)
               TRADE_ON = false;
         }
      }
      else Alert("   .    .");
   }
   //2.1.     (TRADE_ON == false)
   if(TRADE_ON == false)
   {
      OrderSelect(Ticket_H,SELECT_BY_TICKET);
      //2.1.1.    (OrderType() == OP_BUY)
      if(OrderType() == OP_BUY && OrderCloseTime() == 0)
      {
         //2.1.1.1.   
         OrderSelect(Ticket_L,SELECT_BY_TICKET);
         if(OrderCloseTime() == 0)
         {
            Cnt = 0;
            while(Ticket_L > 0 && Cnt < 10)
            {
               Cnt++;
               if(OrderDelete(Ticket_L, CLR_NONE))
               {
                  //2.1.1.2.     (Ticket_Open = Ticket_H)
                  Ticket_Open = Ticket_H;
                  //2.1.1.3.      
                   Ticket_H = 0; Ticket_L = 0; 
               }
               ERROR = GetLastError();
               if(ERROR == 0 && Sound_ON) PlaySound(Name_Sound_Close);
               Error(Name_Expert, "Del Boot - ", ERROR);
            }
         }
         else 
         {
            Ticket_Open = Ticket_H;
            Ticket_H = 0; Ticket_L = 0; 
         }
      }

      OrderSelect(Ticket_L,SELECT_BY_TICKET);
      //2.1.2.    (OrderType() == OP_SELL)
      if(OrderType() == OP_SELL && OrderCloseTime() == 0)
      {
         //2.1.2.1.   
         OrderSelect(Ticket_H,SELECT_BY_TICKET);
         if(OrderCloseTime() == 0)
         {
            Cnt = 0;
            while(Ticket_H > 0 && Cnt < 10)
            {
               Cnt++;
               if(OrderDelete(Ticket_H, CLR_NONE))
               {
                  //2.1.2.2.     (Ticket_Open = Ticket_L)
                  Ticket_Open = Ticket_L;
                  //2.1.2.3.      
                  Ticket_H = 0; Ticket_L = 0; 
               }
               ERROR = GetLastError();
               if(ERROR == 0 && Sound_ON) PlaySound(Name_Sound_Close);
               Error(Name_Expert, "Del Top - ", ERROR);
            }
         }
         else 
         {
            Ticket_Open = Ticket_L;
            Ticket_H = 0; Ticket_L = 0; 
         }
      }
      //2.1.3.   ,     (Ticket_Open > 0)
      if(Ticket_Open > 0)
      {
         //2.1.3.1.   ,  ,  
         if(MarketInfo(Symbol_Name,MODE_STOPLEVEL) > Std_Min_Dist)
         {
            OrderSelect(Ticket_Open,SELECT_BY_TICKET);
            //2.1.3.1.1. TP    0 
            if(OrderTakeProfit() != 0)
            {
               //2.1.3.1.1.1.    
               if(OrderProfit() >= 0)
               {
                  //2.1.3.1.1.1.1.  TP (TP = 0)
                  Cnt = 0;
                  while(!OrderModify(Ticket_Open,OrderOpenPrice(),OrderStopLoss(),0,0,CLR_NONE) && Cnt < 10) Cnt ++;
                  ERROR = GetLastError();
                  if(ERROR == 0)
                  {
                     if(Sound_ON) PlaySound(Name_Sound_Modify);
                     Alert("   .  Take_Profit .");
                  }                     
                  Error(Name_Expert, "Modify - ", ERROR);
               }
            }
         }
         //2.1.3.2.  ,  ,  
         if(MarketInfo(Symbol_Name,MODE_STOPLEVEL) == Std_Min_Dist)
         {
            OrderSelect(Ticket_Open,SELECT_BY_TICKET);
            //2.1.3.2.1. TP = 0 
            if(OrderTakeProfit() == 0 && OrderCloseTime() == 0)
            {
               //2.1.3.2.1.1.   
               Cnt = 0;
               while(!OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), Slip, CLR_NONE) && Cnt < 10) Cnt++;
               ERROR = GetLastError();
               Error(Name_Expert, "Close " + OrderType() + " - " , ERROR);
            }

            OrderSelect(Ticket_Open,SELECT_BY_TICKET);
            //2.1.3.2.2.  Ticket_Open  (OrderCloseTime() > 0)
            if(OrderCloseTime() > 0)
            {
               //    
               if(OrderOpenPrice()!= OrderClosePrice())
               {
                  //2.1.3.2.2.1.  
                  if(OrderProfit() < 0 && MARTIN)
                  {                  
                     //2.1.3.2.2.1.1.  
                     Lot = Lot*2;
                     if(Sound_ON) PlaySound(Name_Sound_Loss);
                  }
                  //2.1.3.2.2.2.  
                  if(OrderProfit() > 0)
                  {
                     //2.1.3.2.2.2.1.     
                     Lot = Set_Lot;
                     if(Sound_ON) PlaySound(Name_Sound_Profit);
                  }
               }
               //2.1.3.2.2.3.            
               Ticket_Open = 0;
               //2.1.3.2.2.4.   
               TRADE_IS_READY = true;//TRADE_ON = true;
               OUTLOSS = SET_OUTLOSS;
            }
            //2.1.3.2.3      
            else 
            {
               OrderSelect(Ticket_Open,SELECT_BY_TICKET);
               if(OrderCloseTime() <= 0 && OUTLOSS) 
               { 
                  int Min_Dist_Cur = MarketInfo(Symbol(),MODE_STOPLEVEL);
                  if(OrderType() == OP_SELL)
                  {
                     if(OrderOpenPrice() - Ask >= (Min_Dist_Cur+Level_OutLoss)*Point) 
                     { 
                        if(OrderModify(Ticket_Open,OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,CLR_NONE))
                           OUTLOSS = false;
                     }
                  }
                  if(OrderType() == OP_BUY)
                  {
                     if(Bid - OrderOpenPrice() >= (Min_Dist_Cur+Level_OutLoss)*Point) 
                     { 
                        if(OrderModify(Ticket_Open,OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,CLR_NONE))
                           OUTLOSS = false;
                     }
                  }
               }
            }
         }
      }
   }
   tral_order();
   output_advert();
//----
   return(0);
}
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                 my_librarias.mqh |
//|                               Copyright  Sergey Gulyaev. Maykop.|
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| My function                                                      |
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//|       
//+------------------------------------------------------------------+
double Check_Set_Lot(string _Symbol_Name, double _Lot)
{
  double _Min_Lot = MarketInfo(_Symbol_Name,MODE_MINLOT);
  if (_Lot < _Min_Lot && _Lot != 0) return(_Min_Lot);
  return(_Lot);
}
int Check_Min_Dist(string _Symbol_Name, double _Param)
{
  double _Min_Dist = MarketInfo(_Symbol_Name,MODE_STOPLEVEL);
  if (_Param < _Min_Dist && _Param != 0) return(_Min_Dist); 
  return(_Param);
}  
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//|   ,   ; 
//| ,   ;
//|  ;  
//|   ; 
//+------------------------------------------------------------------+
bool Error(string _Name_Expert, string _Action, int _Num_Error)
{
  string _Txt_Error = "";
  switch(_Num_Error)
  { //----  ,   :
    case 0:   _Txt_Error = " ";                                               break;
    case 1:   _Txt_Error = " ,   ";                      break;
    case 2:   _Txt_Error = " ";                                             break;
    case 3:   _Txt_Error = " ";                                   break;
    case 4:   _Txt_Error = "  ";                                    break;
    case 5:   _Txt_Error = "   ";                      break;
    case 6:   _Txt_Error = "    ";                            break;
    case 7:   _Txt_Error = " ";                                        break;
    case 8:   _Txt_Error = "  ";                                   break;
    case 9:   _Txt_Error = "   ";             break;
    case 64:  _Txt_Error = " ";                                        break;
    case 65:  _Txt_Error = "  ";                                 break;
    case 128: _Txt_Error = "    ";                    break;
    case 129: _Txt_Error = " ";                                        break;
    case 130: _Txt_Error = " ";                                       break;
    case 131: _Txt_Error = " ";                                       break;
    case 132: _Txt_Error = " ";                                             break;
    case 133: _Txt_Error = " ";                                       break;  
    case 134: _Txt_Error = "    ";               break;
    case 135: _Txt_Error = " ";                                          break;
    case 136: _Txt_Error = " ";                                                 break;
    case 137: _Txt_Error = " ";                                             break;
    case 138: _Txt_Error = " ";                                               break;
    case 139: _Txt_Error = "    ";                  break;
    case 140: _Txt_Error = "  ";                                 break;
    case 141: _Txt_Error = "  ";                                   break;
    case 145: _Txt_Error = " ,     ";      break;
    case 146: _Txt_Error = "  ";                               break;
    case 147: _Txt_Error = "     ";   break;
    case 148: _Txt_Error = "   .";                     break;
    //----    MQL4-:
    case 4000: _Txt_Error = " ";                                              break;
    case 4001: _Txt_Error = "  ";                          break;
    case 4002: _Txt_Error = "  -  ";                          break;
    case 4003: _Txt_Error = "    ";                            break;
    case 4004: _Txt_Error = "    ";            break;
    case 4005: _Txt_Error = "      ";             break;
    case 4006: _Txt_Error = "    ";                     break;
    case 4007: _Txt_Error = "    ";                         break;
    case 4008: _Txt_Error = " ";                             break;
    case 4009: _Txt_Error = "   ";                   break;
    case 4010: _Txt_Error = "    ";                       break;
    case 4011: _Txt_Error = "  ";                                  break;
    case 4012: _Txt_Error = "    ";                              break;
    case 4013: _Txt_Error = "  ";                                         break;
    case 4014: _Txt_Error = " ";                                     break;
    case 4015: _Txt_Error = " ";                                    break;
    case 4016: _Txt_Error = " ";                             break;
    case 4017: _Txt_Error = " DLL  ";                                 break;
    case 4018: _Txt_Error = "  ";                         break;
    case 4019: _Txt_Error = "  ";                              break;
    case 4020: _Txt_Error = "     ";        break; 
    case 4021: _Txt_Error = "   ,   "; break;
    case 4022: _Txt_Error = " ";                                          break;
    case 4050: _Txt_Error = "   ";              break;
    case 4051: _Txt_Error = "   ";                 break;
    case 4052: _Txt_Error = "   ";                     break;
    case 4053: _Txt_Error = " ";                                          break;
    case 4054: _Txt_Error = "  -";            break;
    case 4055: _Txt_Error = "  ";                     break;
    case 4056: _Txt_Error = " ";                                    break;
    case 4057: _Txt_Error = "   ";                 break;
    case 4058: _Txt_Error = "   ";                     break;
    case 4059: _Txt_Error = "     ";                  break;
    case 4060: _Txt_Error = "  ";                                    break;
    case 4061: _Txt_Error = "  ";                                   break;
    case 4062: _Txt_Error = "   string";                          break;
    case 4063: _Txt_Error = "   integer";                         break;
    case 4064: _Txt_Error = "   double";                          break;
    case 4065: _Txt_Error = "    ";                   break;
    case 4066: _Txt_Error = "     ";  break;
    case 4067: _Txt_Error = "    ";                 break;
    case 4099: _Txt_Error = " ";                                             break;
    case 4100: _Txt_Error = "    ";                              break;
    case 4101: _Txt_Error = "  ";                                  break;
    case 4102: _Txt_Error = "   ";                           break;
    case 4103: _Txt_Error = "  ";                                 break;
    case 4104: _Txt_Error = "    ";                     break;
    case 4105: _Txt_Error = "    ";                                 break;
    case 4106: _Txt_Error = " ";                                      break;
    case 4107: _Txt_Error = "     ";         break;
    case 4108: _Txt_Error = "  ";                                   break;
    case 4109: _Txt_Error = "  .   .";     break;
    case 4110: _Txt_Error = "   .    .";  break;
    case 4111: _Txt_Error = "   .    ."; break;
    case 4200: _Txt_Error = "  ";                                   break;
    case 4201: _Txt_Error = "   ";                  break;
    case 4202: _Txt_Error = "  ";                                    break;
    case 4203: _Txt_Error = "  ";                                 break;
    case 4204: _Txt_Error = "  ";                                       break;
    case 4205: _Txt_Error = "  ";                                break;
    case 4206: _Txt_Error = "   ";                            break;
    case 4207: _Txt_Error = "    ";                            break;
    default:   _Txt_Error = " ";
  }
  Print(_Name_Expert+","+_Action+": "+_Txt_Error);
//----
  return(0);
}
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//|  
//+------------------------------------------------------------------+
void tral_order()
{
   if(Tral == 0)return;
   if(Timer_Tral !=0)
   {  if(!SET_TIMER_TRAL)                                     
      {  Timer_Tral = TimeCurrent();                          
         SET_TIMER_TRAL = true;
      }                                                          
      if(SET_TIMER_TRAL)                                     
      {  if(TimeCurrent() <  Timer_Tral + Hold_Before_Tral) return;
         SET_TIMER_TRAL = false;
      }
   }
   int i;
   for(i=OrdersTotal(); i>=0; i--) 
   {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderCloseTime() <= 0 && OrderMagicNumber() == Magic) 
      { 
         if(OrderType() == OP_BUY)
         {
            if(Bid - OrderStopLoss() > Tral*Point)
            { 
               OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Bid - Tral*Point,Digits),OrderTakeProfit(),0,CLR_NONE);
               Error(Name_Expert, ": Traling BUY", GetLastError());
            }
         }
         if(OrderType() == OP_SELL)
         {
            if(OrderStopLoss() - Ask > Tral*Point)
            { 
               OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Ask + Tral*Point,Digits),OrderTakeProfit(),0,CLR_NONE);
               Error(Name_Expert, ": Traling SELL", GetLastError());
            }
         }
      }
   }
   return;
}
//+-------------------------------------------------------------------
//+-------
//+-------
//+------------------------------------------------------------------+
//| 
//+------------------------------------------------------------------+
void output_advert()
{
   #define ADVERT "BlueDream -  !"
   ObjectCreate ("Advert", OBJ_LABEL, 0, 0, 0);
   ObjectSet    ("Advert", OBJPROP_CORNER, 2);
   ObjectSet    ("Advert", OBJPROP_XDISTANCE, 5);
   ObjectSet    ("Advert", OBJPROP_YDISTANCE, 5);
   ObjectSetText("Advert", ADVERT, 10, "Arial", LimeGreen);
   return;
}
//+------------------------------------------------------------------+
//+-------

